package com.bpcl.lpg.core.dao.impl;

import de.hybris.platform.servicelayer.search.SearchResult;
import java.util.Collections;
import java.util.Objects;
import java.util.Map;
import de.hybris.platform.servicelayer.search.FlexibleSearchQuery;
import java.util.HashMap;
import java.util.List;
import com.bpcl.lpg.core.enums.GenericStatusEnum;
import java.util.Date;
import com.bpcl.lpg.core.dao.CODRefillsReportDao;
import com.bpcl.lpg.core.model.CODRefillsModel;
import de.hybris.platform.servicelayer.internal.dao.DefaultGenericDao;

public class CODRefillsReportDaoImpl extends DefaultGenericDao<CODRefillsModel> implements CODRefillsReportDao
{
    public CODRefillsReportDaoImpl(final String typecode) {
        super(typecode);
    }
    
    public List<CODRefillsModel> getCODRefillTransaction(final Date startDate, final Date endDate, final GenericStatusEnum codStatus) {
        final StringBuilder query = new StringBuilder("SELECT {cr.pk} from {").append("CODRefills").append(" as cr JOIN ").append("GenericStatusEnum").append(" as gse on {cr.").append("status").append("}={gse.pk}} WHERE {gse.code}=?").append("status").append(" AND {cr.").append("creationtime").append("}>= ?").append("startTime").append(" AND {cr.").append("creationtime").append("}<= ?").append("endTime");
        final Map<String, Object> param = new HashMap<String, Object>();
        param.put("status", codStatus.getCode());
        param.put("startTime", startDate);
        param.put("endTime", endDate);
        final FlexibleSearchQuery flexibleSearchQuery = new FlexibleSearchQuery(query);
        flexibleSearchQuery.addQueryParameters((Map)param);
        final SearchResult<CODRefillsModel> search = (SearchResult<CODRefillsModel>)this.getFlexibleSearchService().search(flexibleSearchQuery);
        return Objects.isNull(search) ? Collections.emptyList() : search.getResult();
    }
}
